
var shares=null;

/**
 * 更新分享服务
 */
function updateSerivces(){
	plus.share.getServices(function(s){
		shares={};
		for(var i in s){
			var t=s[i];
			shares[t.id]=t;
		}
	}, function(e){
		mui.toast('获取分享服务列表失败：'+e.message);
	});
}

/**
   * 图文消息准备
   * @param {JSON} msg 带content的分享内容对象
   * @param {Array} imgs 分享图片的网络地址
   * @param {Number} type 0-安卓朋友圈，1-安卓微信好友，其他参数-调起系统分享
   */
function preShare(msg, imgs, type){
	var dCount = 0, waiting = null;
	msg.pictures = [];
	window.setClipbordText && setClipbordText(msg.content, '已复制文案到剪贴板');
	
	if(imgs.length < 1) {
		type > 2 ? shareSystem(msg) : shareSystem(msg, type);
		return;
	}
	for(var i=0, len = imgs.length; i<len; i++){
		var filepath="_doc/update/";
		if(imgs[i].indexOf('file:///') > -1){ // 若是海报，则已经是本地路径
			msg.pictures.push(imgs[i]);
			dCount++;
			waiting ? waiting.setTitle('正在下载第' + (dCount+1) + '张图片') : waiting = plus.nativeUI.showWaiting('正在下载第' + (dCount+1) + '张图片', {padding: '20px', padlock: true, back: 'close'});
			if(dCount==len){
				waiting && waiting.close();
				type > 1 ? shareSystem(msg) : shareSystem(msg, type);
			}
			continue;
		}
		imgs[i].toLowerCase().indexOf('.ss2')>-1 ? filepath += new Date().getTime()+'tb.jpg' : filepath = filepath;
		plus.downloader.createDownload(imgs[i], {filename:filepath}, function(d, status){
			// 下载完成
			if ( status == 200 ) {
				msg.pictures.push(d.filename);//sdcardDir 
				dCount++;
				waiting ? waiting.setTitle('正在下载第' + (dCount+1) + '张图片') : waiting = plus.nativeUI.showWaiting('正在下载第' + (dCount+1) + '张图片', {padding: '20px', padlock: true, back: 'close'});
				if(dCount==len){
					waiting && waiting.close();
					type > 1 ? shareSystem(msg) : shareSystem(msg, type);
				}
			} else {
				mui.toast( '有一张图片下载失败',{ duration:'long', type:'div' } ); 
				dCount++; 
				waiting ? waiting.setTitle('正在下载第' + (dCount+1) + '张图片') : waiting = plus.nativeUI.showWaiting('正在下载第' + (dCount+1) + '张图片', {padding: '20px', padlock: true, back: 'close'});
				if(dCount==len){
					waiting && waiting.close();
					type > 1 ? shareSystem(msg) : shareSystem(msg, type);
				}
			}
		}).start()
	}
}

/**
   * 分享操作
   * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
   * @param {Boolean} bh 是否分享链接
   */
function shareAction(sb,bh,msg) {
//	outSet('分享操作：');
	if(!sb||!sb.s){
		mui.toast('无效的分享服务！');
		return;
	}
	var msg = msg || {content:'没有内容',extra:{scene:sb.x}};
	msg.extra = {scene:sb.x};
	// 发送分享
	if(sb.s.authenticated){
//		outLine('---已授权---');
		shareMessage(msg, sb.s);
	}else{
//		outLine('---未授权---');
		sb.s.authorize(function(){
			shareMessage(msg,sb.s);
		}, function(e){
			mui.toast('认证授权失败：'+e.code+' - '+e.message);
		});
	}
}
/**
   * 发送分享消息
   * @param {JSON} msg
   * @param {plus.share.ShareService} s
   */
function shareMessage(msg, s){
//	outLine(JSON.stringify(msg));
	s.send(msg, function(){
//		outLine('分享到"'+s.description+'"成功！');
	}, function(e){
		if(e.message.indexOf('缩略图超过限制') >= 0){
			mui.toast('分享到"'+s.description+'"失败: 貌似缩略图有点大...囧');
		}
		console.log('分享到"'+s.description+'"失败: '+JSON.stringify(e));
	});
}
/**
 * 解除所有分享服务的授权
 */
function cancelAuth(){
	try{
	//	outSet('解除授权：');
		for(var i in shares){
			var s=shares[i];
			if(s.authenticated){
	//			outLine('取消"'+s.description+'"');
			}
			s.forbid();
		}
		// 取消授权后需要更新服务列表
		updateSerivces();
//		outLine('操作成功！');
	}catch(e){alert(e);}
}


// 打开分享
function shareShow(msg){
	var shareBts=[];
	// 更新分享列表
	var ss=shares['weixin'];
	if(navigator.userAgent.indexOf('qihoo')<0){  //在360流应用中微信不支持分享图片
		ss&&ss.nativeClient&&(shareBts.push({title:'微信朋友圈',s:ss,x:'WXSceneTimeline'}),
		shareBts.push({title:'微信好友',s:ss,x:'WXSceneSession'}));
	}
//	ss=shares['sinaweibo'];
//	ss&&shareBts.push({title:'新浪微博',s:ss});
	ss=shares['qq'];
	ss&&ss.nativeClient&&shareBts.push({title:'QQ',s:ss});
	// 弹出分享列表
	shareBts.length>0?plus.nativeUI.actionSheet({title:'分享',cancel:'取消',buttons:shareBts}, function(e){
		(e.index>0)&&shareAction(shareBts[e.index-1],false,msg);
	}):plus.nativeUI.alert('当前环境无法支持分享操作!');
}
// 分析链接
function shareHref(){
	var shareBts=[];
	// 更新分享列表
	var ss=shares['weixin'];
	ss&&ss.nativeClient&&(shareBts.push({title:'微信朋友圈',s:ss,x:'WXSceneTimeline'}),
	shareBts.push({title:'微信好友',s:ss,x:'WXSceneSession'}));
	ss=shares['qq'];
	ss&&ss.nativeClient&&shareBts.push({title:'QQ',s:ss});
	// 弹出分享列表
	shareBts.length>0?plus.nativeUI.actionSheet({title:'分享链接',cancel:'取消',buttons:shareBts},function(e){
		(e.index>0)&&shareAction(shareBts[e.index-1],true);
	}):plus.nativeUI.alert('当前环境无法支持分享链接操作!');
}
/**
 * 调用系统分享
  */
function shareSystem(msg,whereShare){
	var msg=msg;
	if(whereShare!==undefined && plus.os.name==='Android'){
		shareSystemNativeJS(msg,whereShare);
		return;
	}
	plus.share.sendWithSystem(msg, function(){
		console.log('Success');
	}, function(e){
		console.log('Failed: '+JSON.stringify(e));
	})
}
//Android平台分享朋友圈多图并自动填写内容
function shareSystemNativeJS(msg,whereShare) {
	if(plus.os.name!=='Android'){
		plus.nativeUI.alert('此平台暂不支持系统分享功能!');
		return;
	}
	var Intent = plus.android.importClass('android.content.Intent');
	var File = plus.android.importClass('java.io.File');
    var Uri = plus.android.importClass('android.net.Uri');
    var ArrayList = plus.android.importClass('java.util.ArrayList');
    var ComponentName = plus.android.importClass('android.content.ComponentName');
    var main = plus.android.runtimeMainActivity();
	
	var intent=new Intent(Intent.ACTION_SEND);
	var localArrayList = new ArrayList();
	var shareto = ['com.tencent.mm.ui.tools.ShareToTimeLineUI', 'com.tencent.mm.ui.tools.ShareImgUI']; //weixin朋友圈/好友
	var localComponentName = new ComponentName("com.tencent.mm", shareto[whereShare]);
            
	for (var i=0; i<msg.pictures.length; i++) {
		var filePath = plus.io.convertLocalFileSystemURL(msg.pictures[i]); //sdcardDir + 
        //console.log('filePath=' + filePath);
        localArrayList.add(Uri.fromFile(new File(filePath)));
	}

	if(msg.pictures.length!=0){ 
//		console.log('image/*');
		intent.setType('image/*');
//		intent.putExtra(Intent.EXTRA_STREAM,uri); //单图使用 
		intent.putParcelableArrayListExtra("android.intent.extra.STREAM", localArrayList); //多图
	}else{
//		console.log('text/plain');
		intent.setType('text/plain');
	}
	intent.setComponent(localComponentName); //直接设置分享到好友/朋友圈
	intent.setAction("android.intent.action.SEND_MULTIPLE"); //发多图
	intent.putExtra(Intent.EXTRA_SCENE,'WXSceneSession');
	intent.putExtra(Intent.EXTRA_SUBJECT,msg.content);
	intent.putExtra(Intent.EXTRA_TEXT,msg.content);
	intent.putExtra("Kdescription", msg.content); //微信分享页面，图片上边的描述
	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
	main.startActivity(Intent.createChooser(intent,msg.content)); //无图时发朋友消息内容
}
