document.addEventListener( "plusready", function(){
    // 监听点击消息事件
    plus.push.addEventListener( "click", function( msg ) {
        // 判断是从本地创建还是离线推送的消息

        logoutPushMsg( msg, 1 );
    }, false );
    // 监听在线消息事件
    plus.push.addEventListener( "receive", function( msg ) {

        logoutPushMsg( msg, 2 );
    }, false );
    /*
     * 推送消息的处理
     *   @params(json, number) msg=>消息体,state=>点击or在线
     */
    function logoutPushMsg(msg, state){
    	var msg = msg || '';
    	if( msg.length <= 0 ) return
    	if( msg.payload && typeof(msg.payload)=='string' ){
    		msg.payload = JSON.parse( msg.payload )
    	}
    	if( msg.payload.type == 1 ){ // 纯消息推送，弹窗展示
    		plus.ui.alert( msg.content, function(){}, msg.title, '关闭' )
    	}else if( msg.payload.type == 2 ){
    		if( state === 1 ){ // 离线推送活动页面直接打开，否则用户确认后打开
    			openPushUrl( msg.payload.url, msg.title )
    		}else{
    			plus.nativeUI.confirm( msg.content, function(e){ if( e.index == 1 ){ openPushUrl( msg.payload.url, msg.title ) } }, {"title":msg.title, "buttons":["关闭","查看"]} );
    		}
    	}else if( msg.payload.type == 3 ){
			plus.nativeUI.confirm( msg.content, function(e){ if( e.index == 1 ){ appUpdate.dlWgt( msg.payload.url ) } }, {"title":msg.title, "buttons":["关闭","更新"]} );
    	}else if( msg.payload.type == 4 ){
			plus.nativeUI.confirm( msg.content, function(e){ if( e.index == 1 ){ window.location.href = msg.payload.url } }, {"title":msg.title, "buttons":["关闭","更新"]} );
    	}
    }
    function openPushUrl( url, title ){
    	setTimeout( function(){
    		if( mui ){
				mui.openWindow({
				    url: './html/new-page.html',
				    createNew: true,
				    extras: {
				    	url: url,
				    	title: title
				    },
				    waiting:{
				      autoShow:true,//自动显示等待框，默认为true
				      title:'传送中...'//等待对话框上显示的提示内容
				    }
				})
			}
    	},500 )
    }
}, false );