"use strict"

import GoodsInfo from "./components/GoodsInfo.vue";
Vue.component('goods-info', GoodsInfo)
var pageVm = new Vue({
	el: '#app',
	data: {
		id: '',
		album: {
			name: '',
			header: '',
			footer: '',
			items: []
		}
	},
	methods: {
		getData: function(){
			var token = null, that = this;
			if(!window.plus){
				document.addEventListener('plusready', this.getData);
				return;
			}
			token = Utils.getToken();
			if(!token) {
				Utils.openWebview('login.html', 'none', {draw: false, transparent: false}, {});
				setTimeout(function(){
					plus.webview.currentWebview().close('none');
				}, 1000);
				return;
			}
			mui("#progressbar").progressbar().show();
			mui.ajax(Utils.host+'/api/qhz/album/topic/'+this.id, {
				data: {token: token},
				type: 'get',
				success: function(res){
					if(res.success){
						that.album = res.data;
					}else{
						mui.toast('获取数据失败：' + res.message)
					}
					mui("#progressbar").progressbar().hide();
				},
				error: function(xhr, type, thrown){
					mui("#progressbar").progressbar().hide();
					mui.toast('网络错误（' + type + '），请稍后重试...')
				}
			})
		},
		getTkl: function(item, index, event){
			if(item.qurl){
				this.tbStraight(item.qurl);
				return;
			}
			var token = null, that = this, tag = event.target;
			token = Utils.getToken();
			if(!token) return;
			mui.ajax(Utils.host+'/api/gettklv2', {
				data: {item_id: item.item_id, token: token},
				type: 'post',
				success: function(res){
					if(res.success){
						that.tbStraight(res.data.url);
						item.tkl = res.data.tkl;
						item.qurl = res.data.url;
						Vue.set(that.album.items, index, item);
					}else{
						mui.toast('获取数据失败：' + res.message)
					}
				},
				error: function(xhr, type, thrown){
					mui.toast('网络错误（' + type + '），请稍后重试...')
				}
			})
		},
		tbStraight: function(url){ // 唤醒TB
			var that = this, url;
			window.setClipbordText && setClipbordText('', '');
			if(mui.os.ios){
				var _url = 'taobao://' + url.replace('http://', '').replace('https://', '');
				plus.runtime.launchApplication({pname: 'com.taobao.taobao',action:_url}, function ( e ) {
					mui.toast('自动唤醒手淘失败...可以尝试复制淘口令然后手动打开淘宝');
					Utils.openWebview(url, 'pop-in', {draw: true, transparent: false}, {"ptitle": "粉丝福利购"});
				}); 
			}else{
				plus.runtime.openURL( url, function(error){
					mui.toast('自动唤醒手淘失败...可以尝试复制淘口令然后手动打开淘宝');
					Utils.openWebview(url, 'pop-in', {draw: true, transparent: false}, {"ptitle": "粉丝福利购"});
				}, 'com.taobao.taobao' );
			}
		}
	}
})
mui.plusReady(function () {
    var ws = plus.webview.currentWebview();
    if(ws.extras && ws.extras.id){
    	pageVm.id = ws.extras.id;
    	pageVm.getData()
    }
    updateSerivces();
});
mui.init({
	gestureConfig: {
		longtap: true
	}
});
mui(document).on('longtap', '.js_longtapCopy', function(){
	var text = this.innerText;
	window.setClipbordText && setClipbordText(text, '复制成功');
});