import list from './components/List.vue';

Vue.component('goodsList', list);
var pageVm = new Vue({
	el: '#app',
	data: {
		sortIndex: 1,
		cateIndex: 1,
		goods: [],
		reqGoods: {
			page: 1,
			page_size: 20,
			cid: 1,
			od: 'hot'
		},
		loading: {
			is: false,
			text: '上拉加载更多'
		},
		species: [
			{ id: 1, icon_url: "./img/clip/woman.png", name: "女装" },
			{ id: 2, icon_url: "./img/clip/motherbaby.png", name: "母婴" },
			{ id: 3, icon_url: "./img/clip/makeups.png", name: "美妆" },
			{ id: 4, icon_url: "./img/clip/home.png", name: "居家日用" },
			{ id: 5, icon_url: "./img/clip/clothes.png", name: "服饰鞋包" },
			{ id: 6, icon_url: "./img/clip/food.png", name: "食品" },
			{ id: 7, icon_url: "./img/clip/style.png", name: "文体车品" },
			{ id: 8, icon_url: "./img/clip/digital.png", name: "数码家电" },
			{ id: 9, icon_url: "./img/clip/man.png", name: "男装" },
			{ id: 10, icon_url: "./img/clip/underwear.png", name: "内衣" },
			//{ id: '', icon_url: "./img/clip/sport.png", name: "运动" },
			{ id: 11, icon_url: "./img/clip/other.png", name: "其它" }
		],
		showCommission: 0
	},
	methods: {
		getGoods: function(){
			var token = null, that = this;
			if(!window.plus){
				document.addEventListener('plusready', this.getGoods);
				return;
			}
			token = Utils.getToken();
//			if(!token) {
//				mui.toast('获取用户信息失败，请稍后重试或重新登录', {duration: 'long'});
//				return;
//			};
			if(token) this.reqGoods.token = token;
			this.loading.is = true;
			this.loading.text = '正在加载...';
			mui.ajax(Utils.host + '/api/qhz/coupon/list', {
				data: this.reqGoods,
				type: 'get',
				success: function(res){
					if(res.success) {
						that.goods = that.goods.concat(res.data);
						that.reqGoods.page++;
						if(res.data.length < that.reqGoods.page_size) that.loading.text = '← 已经到底啦 →';
						else that.loading.text = '上拉加载更多';
					}else{
						mui.toast('获取商品列表失败：' + res.message);
						that.loading.text = '上拉加载更多';
					} 
					that.loading.is = false;
				},
				error: function(xhr, type, thrown){
					that.loading.text = '上拉加载更多';
					that.loading.is = false;
					mui.toast('网络错误（' + type + '），获取商品列表失败')
				}
			})
		},
		thisCate: function(){
			
		},
		thisSort: function(){
			var s = event.target.getAttribute('data-params');
			if(!s) return; 
			this.goods = [];
			this.reqGoods.od = s;
			this.reqGoods.page = 1;
			this.activeSwitch(2, event.target.getAttribute('data-index'));
			pageVm.getGoods();
		},
		getSpecies: function(){
			var that = this;
			mui.get(Utils.host+'/api/qhz/categorys', {}, function(res){
				if(res.success) that.species = res.data;
			})
		},
		activeSwitch: function(type, index){
			var it = (type===1 ? 'cateIndex' : 'sortIndex'); 
			if(index == this[it]) return;
			this[it] = index;
		}
	},
	mounted: function(){
		this.getSpecies()
	}
});
mui('#scrollCate').on('tap', '.mui-control-item', function(){
	var cid = this.getAttribute('data-id');
	if(!cid) return false;
	pageVm.goods = [];
	pageVm.reqGoods.cid = cid;
	pageVm.reqGoods.od = 'hot';
	pageVm.reqGoods.page = 1;
	pageVm.getGoods();
});
mui.init();
setTimeout(function(){
	mui('#scrollCate').scroll({
		scrollY: false,
		scrollX: true,
		startX: 0
	});
}, 500);
mui.plusReady(function () {
    var ws = plus.webview.currentWebview();
    if(ws.extras && ws.extras.cid) pageVm.reqGoods.cid = pageVm.cateIndex = ws.extras.cid;
    pageVm.getGoods();
    Utils.openPageListener();
    if(plus.storage.getItem('loginData')){
		var loginData = JSON.parse(plus.storage.getItem('loginData'));
		if(loginData.identity && loginData.identity>1) pageVm.showCommission = 1;
		else pageVm.showCommission = 0;
	}
});
document.addEventListener('plusscrollbottom', function(){
	if(pageVm.loading.is) return;
	else pageVm.getGoods();
}, false)