"use strict"
import GoodsList from "./components/List.vue"
import Sort from "./components/Sort.vue"

Vue.component('goods-list', GoodsList)
Vue.component('sort-temp', Sort)

var pageVm = new Vue({
	el: '#app',
	data: {
		goods: [],
		api: '/api/cms/coupon/list?is_jhs=1',
		reqData: {
			od: 'hot',
			page_size: 20,
			page: 1
		},
		groupId: 1
	},
	methods: {
		getData: function () {
			var token = null, that = this;
			if (!window.plus) {
				document.addEventListener('plusready', this.getData);
				return;
			}
			token = Utils.getToken();
			if (token) this.reqData.token = token;
			mui("#commonProgress").progressbar().show();
			mui.ajax(Utils.host + this.api, {
				data: this.reqData,
				type: 'get',
				success: function (res) {
					var nomore = false;
					if (res.success) {
						that.goods = that.goods.concat(res.data);
						that.reqData.page++;
						if (res.data.length < that.reqData.page_size) nomore = true; // no more data
					}
					else mui.toast('获取商品列表失败：' + res.message);
					
					mui("#commonProgress").progressbar().hide();
					mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(nomore);
				},
				error: function (xhr, type, thrown) {
					mui("#commonProgress").progressbar().hide();
					mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(false);
					mui.toast('网络错误（' + type + '），获取商品列表失败')
				}
			})
		},
		pullrefresh: function (sortParam) {
			console.log(sortParam);
			if (sortParam) { this.reqData.od = sortParam.od; }
			this.goods = [];
			this.reqData.page = 1;
			mui('.mui-scroll-wrapper').pullRefresh().refresh(true);
			this.getData();
		}
	}
})
mui.init({
	pullRefresh: {
		container: '.mui-scroll-wrapper',
		up: {
			contentnomore: '← 到底啦 →',
			callback: pageVm.getData
		}
	}
});
mui.plusReady(function () {
	var ws = plus.webview.currentWebview();
	if (ws.extras && ws.extras.url) {
		pageVm.api = ws.extras.url;
		setTimeout(function () {
			pageVm.getData();
		}, 200)
	}
	Utils.openPageListener();

	if(plus.storage.getItem('loginData')) pageVm.groupId = JSON.parse(plus.storage.getItem('loginData')).identity;
}) 