"use strict"
import GoodsInfo from "./components/GoodsInfo.vue"

Vue.component('goods-info', GoodsInfo)
var pageVm = new Vue({
    el: '#app',
    data: {
        goodsInfo: {},
        reqData: {},
        detailsMore: [],
        loadingMore: {
        	show: true,
        	text: '正在请求...'
        },
        sliderImgs: []
    },
    methods: {
    	getData: function(){
    		var token = null, that = this;
			if(!window.plus){
				document.addEventListener('plusready', this.getData);
				return;
			}
			token = Utils.getToken();
			if(token) this.reqData.token = token;
			mui.ajax(Utils.host+'/api/qhz/coupon/detail', {
				data: this.reqData,
				type: 'get',
				success: function(res){
					if(res.success){
						that.goodsInfo = res.data;
						that.sliderImgs = res.data.imgs;
						updateSlider(that.sliderImgs);
						that.goodsInfo.ptitle = '创建分享';
						that.crawlTb(res.data.coupon_url);
					}else{
						mui.toast('获取详细数据失败：' + res.message, {duration: 'long'})
					}
				},
				error: function(xhr, type, thrown){
					mui.toast('网络错误（' + type + '），请稍后重试...')
				}
			})
    	},
    	getDetails: function(){
    		var that = this, data;
    		if(!this.loadingMore.show) return;
    		if(!this.goodsInfo.item_id) {
    			loadingMore.text = '亲，稍等片刻再点开试试';
    			return;
    		};
    		mui.ajax('https://hws.m.taobao.com/cache/mtop.wdetail.getItemDescx/4.1/', {
				data: {
					data: '{item_num_id:' + this.goodsInfo.item_id + '}'
				},
				type: 'get',
				success: function(res){
					console.log(JSON.stringify(res));
					if(res.ret[0].substring(0, 7).toLowerCase() == 'success'){
						that.detailsMore = res.data.images;
						that.loadingMore.text = '请求成功，请等待图片加载完毕';
						that.loadingMore.show = false;
					}else{
						that.loadingMore.text = '糟糕，加载失败了：' + res.ret[0];
					}
				},
				error: function(xhr, type, thrown){
					that.loadingMore.text = '网络错误（' + type + '），请稍后重试...';
				}
			})
    	},
    	crawlTb: function(url){ // 验证券的有效性
			var _url = url.replace('coupon/edetail', 'cp/coupon'), that = this;
			mui.get(_url, {}, function(res){
				if(res.success && res.result.retStatus!==0){
					if( that.reqData.ftb==0 ) that.outOfDate();
					if(res.result.item){
						that.tklTbPage(res.result.item.clickUrl, res.result.item.title, res.result.item.picUrl);
						that.goodsInfo.coupon_url = res.result.item.clickUrl
					}
				}
			})
		},
		outOfDate: function(){ // 通知过期券下线
			mui.ajax( Utils.host+'/api/qhz/offline_notify', {
				type: 'post',
				data: {id: this.reqData.id},
				success: function(res){},
			})
		},
		tklTbPage: function(url, t, pic){
			var that = this, token = Utils.getToken();
			mui.post(Utils.host+'/api/gettkl', {
				click_url: url||'', title: t||'', pic: pic||'', token: token
			}, function(res){
				if(res.success && res.data.tkl) that.goodsInfo.tkl = res.data.tkl;
			})
		},
		tbStraight: function(){ // 唤醒TB
			if(!plus.storage.getItem('loginData')){
				Utils.openWebview('login.html', 'fade-in', {draw: false, transparent: false}, {});
				return;
			}
			var that = this;
			window.setClipbordText && setClipbordText('', '');
			if(mui.os.ios){
				var _url = 'taobao://'+this.goodsInfo.coupon_url.replace('http://', '').replace('https://', '');
				plus.runtime.launchApplication({pname: 'com.taobao.taobao',action:_url}, function ( e ) {
					var _tburl = that.goodsInfo.coupon_url;
					if(_tburl.indexOf('http://')<0 && _tburl.indexOf('https://')<0) { _tburl = 'http://'+_tburl };
					Utils.openWebview(_tburl, 'pop-in', {draw: true, transparent: false}, {"ptitle": "粉丝福利购"});
				}); 
			}else{
				plus.runtime.openURL( this.goodsInfo.coupon_url, function(error){ }, 'com.taobao.taobao' );
				setTimeout(function(){
					openQurl(that.goodsInfo.coupon_url)
				}, 1000)
			}
		},
		toShare: function(){
			if(!plus.storage.getItem('loginData')){
				Utils.openWebview('login.html', 'fade-in', {draw: false, transparent: false}, {});
				return;
			}
			Utils.openWebview('goods-share.html', 'pop-in', {draw: true, transparent: false}, this.goodsInfo);
		}
    }
});
function openQurl(url){
	var _tburl = url;
	if(_tburl.indexOf('http://')<0 && _tburl.indexOf('https://')<0) { _tburl = 'http://'+_tburl };
	Utils.openWebview(_tburl, 'pop-in', {draw: true, transparent: false}, {"ptitle": "粉丝福利购"});
};
mui('.mui-table-view').on('tap', '.js_dMore', function(){
	pageVm.getDetails();
});
mui.plusReady(function () {
    var ws = plus.webview.currentWebview();
    if(ws.extras){
    	pageVm.goodsInfo = ws.extras;
    	pageVm.reqData.id = ws.extras.id;
    	pageVm.reqData.ftb = ws.extras.ftb;
    	pageVm.reqData.amount = ws.extras.amount;
    	pageVm.getData()
    };
//  Utils.openPageListener();
});
// 更新商品轮播
function updateSlider(imgs){
	var slider = plus.nativeObj.View.getViewById('goods-details.html'), images = [];
	for(var i = 0, len = imgs.length; i < len; i++){
		images.push({
			src: imgs[i], width: '100%', verticalAlign: 'top'
		})
	}
	slider.addImages(images);
}
mui.init({
	gestureConfig: {
		longtap: true
	}
});
mui(document).on('longtap', '.js_longtapCopy', function(){
	var text = this.innerText;
	window.setClipbordText && setClipbordText(text, '复制成功');
});
window.addEventListener('fireEvent', function(){
	pageVm.getData()
})
