/**
 * 绘制分享海报
 * @param {Number} t 海报类型-> 1：商品，2：APP分享，3：专辑
 * @param {JSON} info pic, url, name...
 * @param {Function} cb callback
 */
window.drawIMG = function(t, info, cb){
	var wa = null, wStyles = {backButtonAutoControl: 'close'}, posterClip = {width: '320px', height: '450px'};
	if(t === 1) wa = 'poster-goods.html';
	else if(t === 2) {
		var qrBitmap = new plus.nativeObj.Bitmap('drawQR');
		qrBitmap.loadBase64Data(info.qrcode);
		wa = 'poster-app.html'; // poster-album.html;
		wStyles.subNViews = [{
			id: 'drawNView',
			styles: {
				height: '569px',
				width: '320px'
			},
			tags: [{
				id: 'drawBG',
				tag: 'img',
				src: info.mainPic
			},{
				id: 'drawQrcode',
				tag: 'img',
				src: qrBitmap,
				position: {width: '100px', height: '100px', right: '109px', bottom: '84px'}
			}]
		}];
		posterClip = {width: '320px', height: '569px'};
	}
	else if(t === 3) wa = 'poster-album.html';
	
	if(wa === null) return false;
	var bitmap = new plus.nativeObj.Bitmap('poster');
	var w = plus.webview.create(wa, 'page-draw', wStyles, {extras: info});
	
//	t === 2 ? setTimeout(function(){ posterDrawing(w, bitmap, cb, posterClip) }, 500) : 
	w.addEventListener('loaded', function(){
		setTimeout(function(){
			posterDrawing(w, bitmap, cb, posterClip);
//			qrBitmap.clear();
		}, 1000)
	});
	
};
function posterDrawing(w, bitmap, cb, posterClip){
	w.draw(bitmap, function(){
		var t = new Date().getTime();
		bitmap.save('_doc/poster/poster' + t + '.jpg', {quality: 100, clip: posterClip}, function(e){
			if(cb) cb(e.target);
			plus.nativeUI.closeWaiting();
			bitmap.clear()
		}, function(e){
			console.log(e.message)
		})
	}, function(e){
		console.log(e.message)
	}, { 
		check: true,
		clip: posterClip
	})
}
